<template>
	<xn-form-container
		:title="formData.id ? '编辑充值方案配置' : '增加充值方案配置'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" :label-col="{span: 5}">
			<a-form-item label="充值金额及以上：" name="rechargeAmount">
				<a-input-number v-model:value="formData.rechargeAmount" style="width: 100%" :min="0" :max="99999999"
								:precision="2" placeholder="请输入充值金额及以上" allow-clear/>
			</a-form-item>
			<a-form-item label="优惠券金额：" name="couponAmount">
				<a-input-number v-model:value="formData.couponAmount" style="width: 100%" :min="0" :max="99999999"
								:precision="2" placeholder="请输入优惠券金额" allow-clear/>
			</a-form-item>
			<a-form-item label="优惠券数量：" name="couponNum">
				<a-input-number v-model:value="formData.couponNum" style="width: 100%" :min="0" :max="99999999"
								:precision="0" placeholder="请输入优惠券数量" allow-clear/>
			</a-form-item>
			<a-form-item label="账户到账金额：" name="accountBalance">
				<a-input-number v-model:value="formData.accountBalance" style="width: 100%" :min="0" :max="99999999"
								:precision="2" placeholder="请输入账户到账金额" allow-clear/>
			</a-form-item>
			<a-form-item label="返点比例（代金券）：" name="rebateRatio">
				<a-input-number v-model:value="formData.rebateRatio" style="width: 100%" :min="0" :max="100"
								:precision="2" placeholder="请输入返点比例（代金券）" addon-after="%" allow-clear/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="bizRechargePlanConfigForm">
import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import bizRechargePlanConfigApi from '@/api/biz/bizRechargePlanConfigApi'
// 抽屉状态
const open = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)

// 打开抽屉
const onOpen = (record) => {
	open.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	}
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	open.value = false
}
// 默认要校验的
const formRules = {
	rechargeAmount: [required('请输入充值金额及以上')],
	couponAmount: [required('请输入优惠券金额')],
	couponNum: [required('请输入优惠券数量')],
	accountBalance: [required('请输入账户到账金额')],
	rebateRatio: [required('请输入返点比例（代金券）')]
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			bizRechargePlanConfigApi
				.bizRechargePlanConfigSubmitForm(formDataParam, formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
		.catch(() => {
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
